import { useAuthenticationStore } from '../stores/authentication';
import { useDeviceStore } from '../stores/device';

export default defineNuxtRouteMiddleware((to, _from) => {
    const authenticationStore = useAuthenticationStore();
    const deviceStore = useDeviceStore();

    if (_from.hash === '#app') deviceStore.setIsCordova(true);

    if (authenticationStore.token === null) {
        if (to.path !== '/login') return navigateTo('/login');
    } else {
        if (to.path === '/login') return navigateTo('/app'); // @todo dynamic variable here
    }
});
  
  