// https://v3.nuxtjs.org/api/configuration/nuxt.config
export default defineNuxtConfig({
	modules: [
		'@pinia/nuxt',
		'@pinia-plugin-persistedstate/nuxt',
		//'@nuxt/tailwindcss',
		"nuxt-headlessui",
		'@vueuse/nuxt',
		'nuxt-icon',
		'@nuxt/image-edge',
		'nuxt-directus',		
	],
	//https://stackblitz.com/github/piniajs/example-nuxt-3
	imports: {
		dirs: ['./stores'],
	},
	pinia: {
		autoImports: [
			// automatically imports `defineStore`
			'defineStore', // import { defineStore } from 'pinia'
			// ['defineStore', 'definePiniaStore'], // import { defineStore as definePiniaStore } from 'pinia'
			'acceptHMRUpdate',
			'storeToRefs', // no need anymore on pages: import { storeToRefs } from 'pinia';
		],
	},
	/*
	headlessui: {
		//prefix: 'Headless'
		prefix: ''
	},
	*/
	components: {
		global: true,
		dirs: ['components']
    }
})
