import { Directus } from '@directus/sdk';

let directus = null;
// using localhost doestn't work on SSR first call, using 127.0.0.1 works
//const directus = new Directus('http://127.0.0.1:3055', { auth: { mode: 'json', staticToken: 'jr3fC9eVdKke4Nt3-RfRF8T19SbT2_aZ' } }); // works
//const directus = new Directus('http://localhost:3055', { auth: { mode: 'json', staticToken: 'jr3fC9eVdKke4Nt3-RfRF8T19SbT2_aZ' } }); // not work on first call

//export const directus = new Directus(config.BACK_URL, { auth: { mode: 'json', autoRefresh: true, staticToken: 'jr3fC9eVdKke4Nt3-RfRF8T19SbT2_aZ'} });
	
export default defineNuxtPlugin(async (nuxtApp) => {
	const config = useRuntimeConfig();
	if (process.server) console.log('Directus nuxt plugin');
	
	if (!directus) directus = new Directus(config.public.directus.url, { auth: { mode: 'json', staticToken: config.public.directus.token } });

	if (process.server) console.log('Directus config initialized:', config.public.directus);
	
	return {
		provide: { directus },
	};
});