import { precise_round } from '../../utils/precise_round';
//import { useDynamicStore } from '../../stores/dynamic';

// app_config + theme_config
export default defineEventHandler(async (event) => {
	console.log('app [SERVER] - new config request: ' + event.node.req.url);

  //const dynamicStore = useDynamicStore();
  //console.log('app [SERVER] - dynamicStore - context name='+dynamicStore.name, dynamicStore.appContext);


	let engine = {
		forceDevReload: false, // put dev environment
		benchmark: true,
		benchmark_start: null,
		benchmark_end: null,
		benchmarkElapsedTime: null,
	};

	// @todo detect hostname or project id

	if (engine.benchmark) engine.benchmark_start = performance.now();

	// load shared app config when route exist (can contains dynamic routes to inject)
	let app_config = null;
	let cacheAppConfigKey = 'cache:app_config';
	let cacheAppConfigExist = await useStorage().hasItem(cacheAppConfigKey);
	if (cacheAppConfigExist && !engine.forceDevReload) {
		app_config = await useStorage().getItem(cacheAppConfigKey);
	} else {
		let fileAppConfigPath = `assets/server/logic/_app.json`;
		app_config = await useStorage().getItem(fileAppConfigPath);
		if (!app_config) {
			console.error('app [SERVER] - app config missing');
			//throw createError({ statusCode: 404, statusMessage: 'Page Not Found' });
		} else {
			console.log('app [SERVER] - write cache for app config');
			await useStorage().setItem(cacheAppConfigKey, app_config);
		}
	}

  // extend theme config
	let theme_config = {
		// custom palette colors
		primary: 'indigo', //'indigo',
		//'bg-primary' => 'bg-primary', // or bg-primary-light or bg-primary-dark
		secondary: '',
		tertiary: '',
	};

  const appContext = { app: app_config, theme: theme_config };
  //dynamicStore.setAppContext(appContext);

	if (engine.benchmark) {
		engine.benchmark_end = performance.now();
		engine.benchmarkElapsedTime = precise_round(engine.benchmark_end - engine.benchmark_start, 2);
		console.log('app [SERVER] - benchmark getConfiguration ' + engine.benchmarkElapsedTime + ' ms');
	}

  //return { app: app_config, theme: theme_config };
  return appContext;
});
