//import { defineStore } from 'pinia'; // no need with auto import on nuxt-dynamic-layer
import jwtDecode from "jwt-decode";

export const useAuthenticationStore = defineStore('authentication', () => {    
    let token = ref(typeof localStorage !== 'undefined' && localStorage['token'] ? JSON.parse(localStorage['token']) : null);
    let user = ref(token.value !== null ? token.value.user : null);
    
    function setToken(_token: any) {
        if (_token === null) {
            delete localStorage['token'];
            token.value = null;
        } else {
            user.value = jwtDecode(_token.access_token);
            
            localStorage['token'] = JSON.stringify({
                access_token: _token.access_token,
                refresh_token: _token.refresh_token,
                user: user.value
            });
    
            token.value = JSON.parse(localStorage['token']);
        }
    }
  
    return { token, user, setToken }
});