//import { defineStore } from 'pinia'; // no need with auto import on nuxt-dynamic-layer

export const useDeviceStore = defineStore('device', () => {
    let isCordova = ref(false)
    let isAppReady = ref(false);

    function setIsCordova(_isCordova: boolean) {
        isCordova.value = _isCordova;
        if (typeof localStorage !== 'undefined') localStorage.isCordova = _isCordova; // protect ssr
    }

    function setIsAppReady(_isAppReady: boolean) {
        isAppReady.value = _isAppReady;
    }

    function onAppReady(callback: Function) {
        if (isCordova.value) {
            if (isAppReady.value) {
                callback();
            } else {
                setTimeout(() => {
                    onAppReady(callback);
                }, 100);
            }
        }
    }
  
    return { isCordova, setIsCordova, isAppReady, setIsAppReady, onAppReady }
});