//import { defineStore } from 'pinia'; // no need with auto import on nuxt-dynamic-layer

export const useLayoutStore = defineStore('layout', () => {
    let title = ref('');
    let displayBack = ref(false);
    let loader = ref(false);
    let displayDialog = ref(false);
    let dialogTitle = ref('');
    let dialogContent = ref('');
    let displayImageBackground = ref(false);

    function setTitle(_title: string, _displayImageBackground: boolean = false) {
        title.value = _title;
        displayImageBackground.value = _displayImageBackground;
    }

    function setDisplayBack(_displayBack: boolean) {
        displayBack.value = _displayBack;
    }

    function setLoader(_loader: boolean) {
        loader.value = _loader;
    }

    function openDialog(_dialogTitle: string, _dialogContent: string) {
        displayDialog.value = true;
        dialogTitle.value = _dialogTitle;
        dialogContent.value = _dialogContent;
    }

    function closeDialog() {
        displayDialog.value = false;
    }
  
    return { title, setTitle, loader, setLoader, displayBack, setDisplayBack, displayDialog, dialogTitle, dialogContent, openDialog, closeDialog, displayImageBackground }
});