//import { defineStore } from "pinia"; // no need with auto import on nuxt-dynamic-layer
//import { useLocalStorage } from '@vueuse/core';

// https://pinia.vuejs.org/cookbook/composables.html#ssr

/*
const mainStoreInitialData = (typeof window !== 'undefined' && window.localStorage.getItem('storeMain') && JSON.parse(window.localStorage.getItem('storeMain'))) || {
	counter: 0,
    name: 'Eduardo',
	isAdmin: true,
    items: [],
    hasChanged: true,
};
console.warn(mainStoreInitialData);
*/

// main is the name of the store. It is unique across your application and will appear in devtools
export const useMainStore = defineStore('main', {
  // a function that returns a fresh state
  state: () => ({
    //counter: mainStoreInitialData.counter,
	counter: 0,
    name: 'Eduardo',
	isAdmin: true,
    items: [],
    hasChanged: true,
  }),
  // optional getters
  getters: {
    // getters receive the state as first parameter
    doubleCounter: (state) => state.counter * 2,
    // use getters in other getters
    doubleCounterPlusOne(): number {
      return this.doubleCounter + 1
    },
  },
  // optional actions
  actions: {
    reset() {
      // `this` is the store instance
      this.counter = 0
    },
  },
  hydrate(state, initialState) {
    // in this case we can completely ignore the initial state since we
    // want to read the value from the browser
    //state.user = useLocalStorage('pinia/auth/login', 'bob')
	console.warn('store_main - init', initialState);
	//state.counter = mainStoreInitialData.counter
  },
  persist: {
    // store options goes here
	key: 'storeMain'
  }
})

if (import.meta.hot) {
  import.meta.hot.accept(acceptHMRUpdate(useMainStore, import.meta.hot))
}
