//import { defineStore } from "pinia"; // no need with auto import on nuxt-dynamic-layer

//import { useApolloClient } from "@vue/apollo-composable";
//import { shopQuery } from "~~/apollo/queries/shop";

export const useShopStore = defineStore("shop", {
  state: () => {
    return {
	  loading: false,
	  menuOpen: false,
      description: "",     
	  moneyFormat: "$",
      localization: {
        country: {
          currency: {
            isoCode: "USD",
          },
        },
      },           
	  navigation: false, // dynamic navigation
	  //navigation: { categories: [], pages: [] },
	  
	  // @todo save current breadcrumb
	  
	  // @todo put global filters / per collection or special page or products
    };
  },
  actions: {
    async getShopGlobals() {
      try {
        this.loading = true;
		/*
        const { resolveClient } = useApolloClient();
        const apolloClient = resolveClient();
        const { data } = await apolloClient.query({
          query: shopQuery,
        });

        if (!data.shop) {
          throw "getShopData: no response";
        }
		*/
		
		//console.log('__getShopGlobals__', process.env);
		
		/*
		const { $directus } = useNuxtApp();
		
		let queryOptions = {
			//fields: options.fields,
			fields: ['*.*'],
			filter: {
				active: {
					'_eq': 1
				}
			},
			//sort: options.sort,
			sort: 'sort, name',
			limit: -1,
		};

		const response = await $directus.items('commerce_categories').readByQuery(queryOptions).catch((err) => {
			console.error('___commerce_categories - load - error', err);
		});
		*/
		
		/*
		let response = null;
	    const requestResult = await useCustomFetch('/commerce/shop');
		
		if (requestResult !== null) {
			if (requestResult._errorCode === null && requestResult._errorStatus === null) {
				response = requestResult._data;
				
				//actionResult = {
				//	success: true,
				//	data: requestResult._data
				//};
				
			}
		}
		*/
		
		
		/*
		  requestResult = await useCustomFetch(requestDetail.url, {
                    ...requestDetail.options,
                    method: requestDetail.method,
                    body: getFormData(requestDetail.data, requestDetail.forms, requestDetail.modifiers)
                });
		*/
				
		const config = useRuntimeConfig();
		console.log('getShopGlobals____config___', config.public.directus);
		
		const { data: response, error } =  await useFetch(config.public.apiBaseUrl+'/commerce/shop');

		/*
		const { data: mountain2, error } = await useAsyncData(
		  () => $fetch(`http://127.0.0.1:3055/items/commerce_categories?fields=*.*,products.product.*&access_token=jr3fC9eVdKke4Nt3-RfRF8T19SbT2_aZ`)  
		   //() => $fetch(`http://localhost:3055/items/commerce_categories?fields=*.*,products.product.*&access_token=jr3fC9eVdKke4Nt3-RfRF8T19SbT2_aZ`)   
		)
		*/
		//console.log('Shop error', error.value);


		console.log('getShopGlobals____response___', response?.value);
		
		//this.navigation = response?.data

        this.description = response?.value?.shop?.description ?? "";
        this.moneyFormat = response?.value?.shop?.moneyFormat ?? "$";
        this.localization = response?.value?.localization ?? {};
		this.navigation = response?.value?.navigation ?? false;
		
		// @todo get dynamic global navigation
		// otherwise use global navigation defined on constants file or app config (useAppConfig)
		
		
      } catch (e) {
        return e;
      } finally {
        this.loading = false;
      }
    },
    toggleMenu(state?: boolean) {
      if (typeof state === "boolean") {
        this.menuOpen = state;
      } else {
        this.menuOpen = !this.menuOpen;
      }
    },
  },
  /*
  persist: {
		key: 'storeShop',
		//storage: persistedState.localStorage // persistedState.sessionStorage,
		storage: persistedState.cookiesWithOptions({
			sameSite: 'strict',
		}),
  }	
  */
});

if (import.meta.hot) {
  import.meta.hot.accept(acceptHMRUpdate(useShopStore, import.meta.hot))
}
