export const stripZeros = (price: number): number => {
  if (price % 1 === 0) {
    return Math.trunc(price);
  }
  return price;
};

export const formatWithCurrency = (
  currencySymbol: string,
  price: number
): string => {
  return `${currencySymbol}${price}`;
};

/*
 * new Intl.NumberFormat('en-US', { style: "currency", currency: 'USD' }).format(40.5);
 * new Intl.NumberFormat('fr-FR', { style: "currency", currency: 'EUR' }).format(40.5);
 */
export const formatLocalePrice = (
  price: number,
  locale: string,
  currency: string
) => {
  return new Intl.NumberFormat(locale, { style: "currency", currency }).format(
    price
  );
};
